$(document).ready(function () {
    //
    prestashop.on(
      'steco_event_init',
      steco.update
    );
    prestashop.on(
      'updateCart', function(event){
        if($('#module-steasycheckout-default').length){    
          if(event && typeof(event.resp)!='undefined' && (!event.resp.cart.products_count || event.resp.cart.minimalPurchaseRequired!='')){
            window.location.reload(true);
          }
          steco.update({'item':28});
        }
      }
    );
    if($('body#module-steasycheckout-default').length && typeof(steasycheckout) != 'undefined'){
      var init_params = {};
      if(window.location.href.indexOf('stripe_error=1')>=0){
        init_params = $.extend(init_params, {'stripe_error':1});
      }
      prestashop.emit('steco_event_init', init_params);
    }

    $(document).on('submit', '#steco_login_form', function(event){
      var $form = $(this);
      var validate = steco_address.verify($form.find('input[name="email"]'),0);
      $form.find('input[name="email"]').closest('.form-group ').toggleClass('st-has-error', !validate);
      if(!validate)
        return false;

      if($form.find('input[name="steco_psgdpr_consent_checkbox"]').length){
        steco.gdprLog($form.find('input[name="steco_psgdpr_consent_checkbox"]'));
      }
      $form.find('.form-footer .steco-btn-spin').addClass('active');
      steco.loading(0);
      $.ajax(
      {
          type: 'POST',
          url: $form.attr('action'),
          data: $form.serialize(),
          dataType: 'json',
          cache: false
      }).then(function (resp) {
        steco.loading(false);
        if(!$(resp.personal_information).find('#steco_pi_forms').length){
          $('.show_incomplete_message').removeClass('show_incomplete_message');
          $('.show_save_address_message').removeClass('show_save_address_message');
          $('.steco_addresses').removeClass('steco_display_none');
          if($('.login.top_bar_item').length){
            $.ajax({
              url: steasycheckout.urls.userinfo,
              method: 'POST',
              dataType: 'json',
              cache: false
            }).then(function (resp) {
              if(resp && typeof(resp.dropdown) != 'undefined'){
                $('.welcome.top_bar_item').remove();
                $('.login.top_bar_item').replaceWith(resp.dropdown);
              }
            }).fail(function(resp) {
              prestashop.emit('stecoHandleError', {eventType: 'userinfo', resp: resp});
            });
          }
        }
        steco.update_dom(resp);
        //
      }).fail(function (resp) {
        steco.loading(false);
        prestashop.emit('stecoHandleError', {eventType: 'authentication', resp: resp});
      });
      return false;
    });
    

    steco_address.init();
    steco_delivery.init();
    steco_payment.init();

    //events in collapse are wired
    $(document).on('hide.bs.collapse', '#steco_pi_forms', function (e) {
      if(!steco.for_steco_collapse){
        steco.for_steco_collapse = 0;
        return false
      }
      steco.for_steco_collapse = 0;
    });
    $(document).on('show.bs.collapse', '#steco_pi_forms', function (e) {
      if($('#steco_pi_forms .card-header :radio:checked').length)
        steco.for_steco_collapse = 1;
      $(e.target).closest(".card").find(".card-header :radio").prop("checked", true);
      $('.steco_addresses').toggleClass('steco_display_none', $('input[name=steco_pi_form]:checked').val()==0);
    });
    //
    $(document).on('click', 'button[data-action="show-password"]', function () {
      var elm = $(this).closest('.input-group').children('input.js-visible-password');
      if (elm.attr('type') === 'password') {
        elm.attr('type', 'text');
        $(this).find('i').removeClass('eco-eye-off eco-eye').addClass('eco-eye');
      } else {
        elm.attr('type', 'password');
        $(this).find('i').removeClass('eco-eye-off eco-eye').addClass('eco-eye-off');
      }
    });
    $(document).on('click', '.js-terms a', function (event) {
      event.preventDefault();
      var url = $(event.target).attr('href');
      if (url) {
        if (url.indexOf('?') != -1)
          url += '&content_only=1';
        else
          url += '?content_only=1';
        $.get(url, function(content) {
          var terms_content = $(content).find('.page-cms').html();
          var terms_easy_content = $(content).find('#body_wrapper .easycontent_container');
          if(terms_easy_content.length){
            terms_easy_content.each(function(){
              terms_content += $(this).wrap('<div/>').parent().html();
            });
          }
          $('#modal').find('.js-modal-content').html(terms_content);
        }).fail(function(resp) {
          prestashop.emit('stecoHandleError', {eventType: 'clickTerms', resp: resp});
        });
      }

      $('#modal').modal({'backdrop': false}).modal('show');
    });

    $(document).on('click', '.steco-gift-checkbox', function (event) {
      $('#gift').collapse('toggle');
    });
    prestashop.on(
      'stecoHandleError',
      steco.handleError
    );
    /*prestashop.on(
      'steco_event_updated',
      steco.gdpr
    );*/
    $(document).on('blur','.steco_pi_form input[name="email"],.steco_pi_form input[name="birthday"]', function(){
        $(this).closest('.form-group ').toggleClass('st-has-error', !steco_address.verify($(this),0));
    });
    $(document).on('blur','.steco_new_address_form input[name="phone"], .steco_new_address_form input[name="postcode"], .steco_new_address_form input[name="firstname"], .steco_new_address_form input[name="lastname"], .steco_new_address_form input[name="address1"]', function(){
        $(this).closest('.form-group ').toggleClass('st-has-error', !steco_address.verify($(this),1));
    });
    $(document).on('blur','#steco_customer_form_register :input[required]', function(){
        if($(this).val())
          $(this).closest('.form-group ').removeClass('has-error');
    });
    $(document).on('blur','.steco_new_address_form :input[required]', function(){
      if($(this).attr('name')=='phone' || $(this).attr('name')=='postcode' || $(this).attr('name')=='firstname' || $(this).attr('name')=='lastname' || $(this).attr('name')=='address1'){
        if($(this).val() && steco_address.verify($(this),1))
          $(this).closest('.form-group ').removeClass('has-error st-has-error');//
      }else{
        if($(this).val())
          $(this).closest('.form-group ').removeClass('has-error st-has-error');//
      }
    });
    $(document).on('change','#steco_customer_form_register input[name="steco_psgdpr_consent_checkbox"]', function(){
      if ($(this).prop('checked') == true)
          $(this).closest('.form-group ').removeClass('st-has-error');
    });
    $(document).on('keyup','.steco_new_address_form input[name="firstname"],.steco_new_address_form input[name="lastname"],.steco_new_address_form input[name="company"],.steco_new_address_form input[name="vat_number"],.steco_new_address_form input[name="dni"]', function(){
      $(this).data('prev_value', $(this).val());
    });
    $(document).on('keyup','#steco_customer_form_register input[name="firstname"],#steco_customer_form_register input[name="lastname"],#steco_customer_form_register input[name="company"],#steco_customer_form_register input[name="siret"]', function(){
      var prev_value = $(this).data('prev_value');
      var field_name = $(this).attr('name');
      if(field_name=='siret')
        field_name = $('.steco_new_address_form').first().find('input[name="vat_number"]').length ? 'vat_number' : 'dni';

      var delivery_dom = $('.st_address_form_delivery input[name="'+field_name+'"]');
      var invoice_dom = $('.st_address_form_invoice input[name="'+field_name+'"]');
      if(delivery_dom.length){
        if(field_name=='firstname' || field_name=='lastname'){
          if(!$('.st_address_form_delivery input[name="p_or_c"]:checked').length || steasycheckout.show_name_for_company || $('.st_address_form_delivery input[name="p_or_c"]:checked').val()!=1){
              if(delivery_dom.val()=='' || delivery_dom.val()==prev_value){
                delivery_dom.val($(this).val());
                delivery_dom.closest('.form-group ').toggleClass('has-error', $(this).val()=='');
              }
          }
          else if($('.st_address_form_delivery input[name="p_or_c"]:checked').length)
            delivery_dom.data('prev_value', $(this).val());
          if(!$('.st_address_form_invoice input[name="p_or_c"]:checked').length || steasycheckout.show_name_for_company || $('.st_address_form_invoice input[name="p_or_c"]:checked').val()!=1){
            if(invoice_dom.val()=='' || invoice_dom.val()==prev_value){
              invoice_dom.val($(this).val());
              invoice_dom.closest('.form-group ').toggleClass('has-error', $(this).val()=='');
            }
          }
          else if($('.st_address_form_invoice input[name="p_or_c"]:checked').length)
            invoice_dom.data('prev_value', $(this).val());
        }else if(field_name=='company' || field_name=='dni'){
          if(!$('.st_address_form_delivery input[name="p_or_c"]:checked').length || $('.st_address_form_delivery input[name="p_or_c"]:checked').val()==1){
              if(delivery_dom.val()=='' || delivery_dom.val()==prev_value){
                delivery_dom.val($(this).val());
                delivery_dom.closest('.form-group ').toggleClass('has-error', $(this).val()=='');
              }
          }
          else if($('.st_address_form_delivery input[name="p_or_c"]:checked').length)
            delivery_dom.data('prev_value', $(this).val());
          if(!$('.st_address_form_invoice input[name="p_or_c"]:checked').length || $('.st_address_form_invoice input[name="p_or_c"]:checked').val()==1){
            if(invoice_dom.val()=='' || invoice_dom.val()==prev_value){
              invoice_dom.val($(this).val());
              invoice_dom.closest('.form-group ').toggleClass('has-error', $(this).val()=='');
            }
          }
          else if($('.st_address_form_invoice input[name="p_or_c"]:checked').length)
            invoice_dom.data('prev_value', $(this).val());
        }else if(field_name=='dni'){
          if(delivery_dom.val()=='' || delivery_dom.val()==prev_value){
            delivery_dom.val($(this).val());
            delivery_dom.closest('.form-group ').toggleClass('has-error', $(this).val()=='');
          }
          if(invoice_dom.val()=='' || invoice_dom.val()==prev_value){
            invoice_dom.val($(this).val());
            invoice_dom.closest('.form-group ').toggleClass('has-error', $(this).val()=='');
          }
        }
      }
      $(this).data('prev_value', $(this).val());
    });
    if(typeof(steasycheckout.sticky_third)!='undefined' && steasycheckout.sticky_third){
      $('.steco_right_inner').stSticky({
        stickTo: $('.steco_container')[0],
          top: steco.sticky_top(),
          responsive: {
            992: {
              disable: true
            }
          }
      });

      prestashop.on(
        'steco_event_updated',
        function(){
          $('.steco_right_inner').stSticky('refresh');
        }
      );
    }
});

var steco = {
    'promises': [],
    'for_steco_collapse': 0,
    'sticky_top': function(){
      var top = 0; 
      if(typeof(steasycheckout.sticky_top)!='undefined' && steasycheckout.sticky_top){
        if(parseInt(steasycheckout.sticky_top,10) == steasycheckout.sticky_top)
          top = steasycheckout.sticky_top;
        else
          top = $(steasycheckout.sticky_top).outerHeight();
      }
      return parseInt(top,10);
    },
    'loading': function(items){
      if(items===false)
        $('.steco_container').removeClass('busy_0 busy_1 busy_2 busy_4 busy_8 busy_16 busy_12 busy_14 busy_24 busy_28 busy_30');
      else
        $('.steco_container').addClass('busy_'+(steasycheckout.display_cart ? 16+items : items));
    },
    'abortPreviousRequests': function() {
        var promise;
        while (this.promises.length > 0) {
            promise = this.promises.pop();
            promise.abort();
        }
    },
    'update': function(params) {
      var item = typeof(params.item)!='undefined' ? params.item : false;
      if(item!==false){
        steco.loading(item)
      }
        steco.abortPreviousRequests();
        $.ajax({
          url: steasycheckout.urls.update+(item!==false ? '&items='+item : '')+(typeof(params.stripe_error)!='undefined' ? '&stripe_error=1' : ''),
          method: 'POST',
          dataType: 'json',
          cache: false,
          beforeSend: function (jqXHR) {
            steco.promises.push(jqXHR);
          }
        }).then(function (resp) {
          if(typeof(resp.redirect) != 'undefined')
            document.location.href = resp.redirect;
          steco.update_dom(resp);
          //
          steco.toggleFormActive();
          steco.loading(false);
        }).fail(function(resp) {
          steco.loading(false);
          prestashop.emit('stecoHandleError', {eventType: 'stecoUpdate', resp: resp});
        });
    },
    'update_dom': function(resp) {
      typeof(resp.personal_information) != 'undefined' && $('.steco_personal_information').html(resp.personal_information);
      (typeof(resp.addresses) != 'undefined' && resp.addresses) && $('.steco_addresses').html(resp.addresses);
      typeof(resp.delivery) != 'undefined' && $('.steco_delivery').html(resp.delivery);
      typeof(resp.payment) != 'undefined' && $('.steco_payment').html(resp.payment);
      if(typeof(resp.cart) != 'undefined'){
        var inputs = [];
        $('.steco_cart #delivery_message').each(function () {
          inputs[$(this).prop('name')] = $(this).val();
        });
        $('.steco_cart #steco-conditions-to-approve input').each(function () {
          inputs[$(this).prop('name')] = $(this).prop("checked");
        });
        $('.steco_cart').html(resp.cart);
        $('.steco_cart #delivery_message').each(function () {
          $(this).val(inputs[$(this).prop('name')]);
        });
        $('.steco_cart #steco-conditions-to-approve input').each(function () {
          $(this).prop("checked", inputs[$(this).prop('name')]);
        });
        /*var $cart = $($.parseHTML(resp.cart));
        $cart.find('#delivery_message').html($('#delivery_message').val());
        $.each($('#steco-conditions-to-approve input'), function(){
          $cart.find('input[name="'+$(this).attr('name')+'"]').prop('checked', $(this).is(':checked'));
        });
        $('.steco_cart').html($cart);*/
        prestashop.emit('updatedCart', {eventType: 'updateCart', resp: {}});
      }
      prestashop.emit('steco_event_updated', resp);
    },
    'personal_information': function() {
        $.ajax({
          url: steasycheckout.urls.personal_information,
          method: 'POST',
          dataType: 'json',
          cache: false,
          beforeSend: function (jqXHR) {
            steco.promises.push(jqXHR);
          }
        }).then(function (resp) {
            steco.update_dom(resp);
            prestashop.emit('steco_event_personal_information', {});
        }).fail(function(resp) {
          prestashop.emit('stecoHandleError', {eventType: 'personalInformation', resp: resp});
        });
    },
    'addresses': function(url){
        $.ajax({
          url: url ? url : steasycheckout.urls.addresses,
          method: 'POST',
          dataType: 'json',
          cache: false,
          beforeSend: function (jqXHR) {
            steco.promises.push(jqXHR);
          }
        }).then(function (resp) {
            steco.update_dom(resp);
            prestashop.emit('steco_event_addresses', {});
        }).fail(function(resp) {
          prestashop.emit('stecoHandleError', {eventType: 'addresses', resp: resp});
        });
    },
    'delivery': function(){
        $.ajax({
          url: steasycheckout.urls.delivery,
          method: 'POST',
          dataType: 'json',
          cache: false,
          beforeSend: function (jqXHR) {
            steco.promises.push(jqXHR);
          }
        }).then(function (resp) {
            steco.update_dom(resp);
            prestashop.emit('steco_event_delivery', {});
        }).fail(function(resp) {
          prestashop.emit('stecoHandleError', {eventType: 'delivery', resp: resp});
        });
    },
    'payment': function(){
        $.ajax({
          url: steasycheckout.urls.payment,
          method: 'POST',
          dataType: 'json',
          cache: false,
          beforeSend: function (jqXHR) {
            steco.promises.push(jqXHR);
          }
        }).then(function (resp) {
            steco.update_dom(resp);
            prestashop.emit('steco_event_payment', {});
        }).fail(function(resp) {
          prestashop.emit('stecoHandleError', {eventType: 'payment', resp: resp});          
        });
    },
    'handleError': function(event){
      if(typeof(event.eventType)!='undefined')
        console.log(event.eventType);
    },
    'gdpr': function(resp){
      if(typeof(resp.personal_information) != 'undefined' && $('input[name="steco_psgdpr_consent_checkbox"]').length){
        $(document).on('click', 'input[name="steco_psgdpr_consent_checkbox"]', function (event) {
          steco.toggleFormActive();
        });
      }
    },
    'gdprLog': function($cb){
        $.ajax({
            data: 'POST',
            //dataType: 'JSON',
            url: $cb.data('front_controller'),
            data: {
                ajax: true,
                action: 'AddLog',
                id_customer: $cb.data('id_customer'),
                customer_token: $cb.data('customer_token'),
                id_guest: $cb.data('id_guest'),
                guest_token: $cb.data('guest_token'),
                id_module: $cb.data('id_module'),
            },
            success: function (data) {
                // parentForm.submit();
            },
            error: function (err) {
            }
        });
    },
    'toggleFormActive': function(){
        $('input[name=steco_psgdpr_consent_checkbox]').each(function(){
              var parentForm = $(this).closest('form');
              if ($(this).prop('checked') == true) {
                  parentForm.find('[type="submit"]').removeAttr('disabled');
              } else {
                  parentForm.find('[type="submit"]').attr('disabled', 'disabled');
              }
          });
    },
    'bu_yao_shan_chu': true
};

var steco_address = {
  'autocomplete': null,
  'autocomplete_invoice': null,
  'state_arr': [],
  process: {
    'validate_delivery': 0,
    'validate_invoice': 0,
    'pi_submit': 0,
    'shipping_submit': 0,
    'billing_submit': 0,
  },
  init: function() {
    $(document).on('submit', '.steco_new_address_form', function(){
      if(!steco_payment.verify_addresses(true))
        return false;
      var $form = $(this);
      $form.find('.form-footer .steco-btn-spin').addClass('active');
      steco.loading(30);
      $.ajax(
      {
          type: 'POST',
          url: $form.attr('action'),
          data: $form.serialize(),
          dataType: 'json',
          cache: false
      }).then(function (resp) {
        steco.update_dom(resp);
        steco.loading(false);
      }).fail(function (resp) {
        steco.loading(false);
        $form.find('.form-footer .steco-btn-spin').removeClass('active');
        prestashop.emit('stecoHandleError', {eventType: 'newAddress', resp: resp}); 
      });
      return false;
    });
    $(document).on('click', '.steco_address_btn', function(){
      /*if (!confirm('Are you sure ?'))
        return false;*/
      var $this = $(this).addClass('active');
      $.ajax({
          type: 'POST',
          url: $this.attr('href'),
          dataType: 'json',
          cache: false
      }).then(function (resp) {
        $this.removeClass('active');
        steco.update_dom(resp);
        prestashop.emit('stecoUpdatedAddress', {target: $('.js-address-form'), resp: resp});
      }).fail(function (resp) {
        $this.removeClass('active');
        prestashop.emit('stecoHandleError', {eventType: 'addressBtn', resp: resp}); 
      });
      return false;
    });
    $(document).on('click', '.steco-cancel-address', function(){
      $('.steco_addresses_form').empty();
      $('.steco_addresses_from').removeClass('steco_display_none');
    });
    $(document).on('click', 'input[name="show_invoice_button"]', function (event) {
      $('.st_address_form_invoice').toggleClass('steco_display_none', $(this).prop('checked') == true);
    });
    /*$(document).on('click', '.steco_address_del_btn', function(){
      steco.addresses($(this).attr('href'));
      return false;
    });*/
    var address_refresh_tri = '.steco-country';
    if(typeof(steasycheckout.stop_state_refresh)=='undefined' || !steasycheckout.stop_state_refresh)
      address_refresh_tri += ',.st_form_item_id_state select[name="id_state"]';

    $(document).on('change', address_refresh_tri, function() {
      //,.steco_new_address_form input[name="postcode"]
      // , select[name="city"] // for Romanian Carriers - Fan Courier
      steco.abortPreviousRequests();
      var formSelector = $(this).closest('.js-address-form').hasClass('st_address_form_delivery') ? '.st_address_form_delivery' : '.st_address_form_invoice';
      // steco.loading(formSelector=='.st_address_form_delivery' ? 30 : 2);
      steco.loading(30);
      var requestData = {
        id_country: $(formSelector).find('.steco-country').val(),
        id_state: $(formSelector).find('select[name="id_state"]').length ? $(formSelector).find('select[name="id_state"]').val() : '',
        postcode: $(formSelector).find('input[name="postcode"]').length ? $(formSelector).find('input[name="postcode"]').val() : '',
        address1: $(formSelector).find('input[name="address1"]').length ? $(formSelector).find('input[name="address1"]').val() : '',
        city: $(formSelector).find('[name="city"]').length ? $(formSelector).find('[name="city"]').val() : '',
        delivery_invoice: $(formSelector).find('input[name="saveAddress"]').val(),
        id_address: $(formSelector + ' form').find('input[name="id_address"]').val()
      };
      var getFormViewUrl = $(formSelector + ' form').data('refresh-url');
      var formFieldsSelector = formSelector + ' input:not([type=radio]),'+formSelector + ' select';//ru guo mei you not radio, suoyou de radio dou hui bei fu yu xiang tong de zhi. 

      $.ajax(
      {
          type: 'POST',
          url: getFormViewUrl,
          data: requestData,
          dataType: 'json',
          cache: false,
          beforeSend: function (jqXHR) {
            steco.promises.push(jqXHR);
          }
      }).then(function (resp) {
        steco.loading(false);

        var inputs = [];

        // Store fields values before updating form
        $(formFieldsSelector).each(function () {
          if($(this).prop('name')=='use_as_delivery_invoice[]' || $(this).prop('name')=='show_invoice_button' || $(this).prop('name')=='id_address')
            return true;
          inputs[$(this).prop('name')] = $(this).val();
        });
        inputs['use_as_delivery_invoice'] = [];
        inputs['use_as_delivery_invoice']['delivery'] = $(formSelector + ' input[name="use_as_delivery_invoice[]"][value="delivery"]').prop("checked");
        inputs['use_as_delivery_invoice']['invoice'] = $(formSelector + ' input[name="use_as_delivery_invoice[]"][value="invoice"]').prop("checked");
        if($(formSelector + ' input[name="show_invoice_button"]').length)
          inputs['show_invoice_button'] = $(formSelector + ' input[name="show_invoice_button"]').prop("checked");
        if($(formSelector + ' input[name="p_or_c"]').length)
          inputs['p_or_c'] = $(formSelector + ' input[name="p_or_c"]:checked').val();
        //
        $(formSelector).replaceWith(resp.address_form);

        // Restore fields values
        $(formFieldsSelector).each(function () {
          if($(this).prop('name')=='use_as_delivery_invoice[]' || $(this).prop('name')=='show_invoice_button' || $(this).prop('name')=='id_address')
            return true;
          $(this).val(inputs[$(this).prop('name')]);
        });
        $(formSelector + ' input[name="use_as_delivery_invoice[]"][value="delivery"]').prop("checked", inputs['use_as_delivery_invoice']['delivery']);
        $(formSelector + ' input[name="use_as_delivery_invoice[]"][value="invoice"]').prop("checked", inputs['use_as_delivery_invoice']['invoice']);
        if(typeof(inputs['show_invoice_button'])!='undefined')
          $(formSelector + ' input[name="show_invoice_button"]').prop("checked", inputs['show_invoice_button']);
        if(typeof(inputs['p_or_c'])!='undefined'){
          $(formSelector + ' input[name="p_or_c"][value='+inputs['p_or_c']+']').prop("checked", true);
          if(inputs['p_or_c']==1){
            $(formSelector+' .st_form_item_company, '+formSelector+' .st_form_item_dni').removeClass('steco_display_none');
            if(!steasycheckout.show_name_for_company)
              $(formSelector+' .st_form_item_firstname, '+formSelector+' .st_form_item_lastname').addClass('steco_display_none');
          }
          else{
            $(formSelector+' .st_form_item_company, '+formSelector+' .st_form_item_dni').addClass('steco_display_none');
            if(!steasycheckout.show_name_for_company)
              $(formSelector+' .st_form_item_firstname, '+formSelector+' .st_form_item_lastname').removeClass('steco_display_none');
          }
        }

        prestashop.emit('updatedAddressForm', {target: $(formSelector), resp: resp});

        steco.update_dom(resp);
      }).fail(function (resp) {
        steco.loading(false);
        prestashop.emit('stecoHandleError', {eventType: 'updateAddressForm', resp: resp}); 
      });
    });

    $(document).on('change', 'input[name=use_same_address]', function() {
      if(this.checked){
        $(':radio[name=id_address_invoice][value='+$(':radio[name=id_address_delivery]:checked').val()+']').prop('checked',true).trigger('change');
      }
      $('.invoice-addresses-container').toggleClass('steco_display_none', this.checked);
    });
    $(document).on('change', ':radio[name=id_address_delivery], :radio[name=id_address_invoice]', function() {
      steco.loading(28);
      steco.abortPreviousRequests();

      $(this).closest('.address-selector').find('.steco-address-item').removeClass('steco_selected steco-input-loadingsteco-input-loading');
      $(this).closest('.steco-address-item').addClass('steco_selected steco-input-loading');

      // var idFailureAddress = $(".js-address-error").prop('id').split('-').pop();
      var notValidAddresses = $('#not-valid-addresses').val();
      var addressType = this.name.split('_').pop();
      var $addressError = $('.js-address-error[name=alert-' + addressType + ']');

      // switchEditAddressButtonColor(false, idFailureAddress, addressType);

      if (notValidAddresses !== "") {
        if (notValidAddresses.split(',').indexOf(this.value) >= 0) {
          $addressError.show();
          // switchEditAddressButtonColor(true, this.value, addressType);
          $(".js-address-error").prop('id', "id-failure-address-" + this.value);
          return false;
        } else {
          $addressError.hide();
        }
      } else {
        $addressError.hide();
      }

      var $form = $('.steco_addresses_from');
      $.ajax(
      {
          type: 'POST',
          url: $form.attr('action'),
          data: $form.serialize(),
          dataType: 'json',
          cache: false,
          beforeSend: function (jqXHR) {
            steco.promises.push(jqXHR);
          }
      }).then(function (resp) {
        steco.update_dom(resp);
        $('.steco-address-item').removeClass('steco-input-loading');
        steco.loading(false);
      }).fail(function (resp) {
        $('.steco-address-item').removeClass('steco-input-loading');
        steco.loading(false);
        prestashop.emit('stecoHandleError', {eventType: 'updateAddressOptions', resp: resp}); 
      });
      return false;
    });
    if(steasycheckout.disallow_po_box){
      $(document).on('keyup', '.steco_addresses_form input[name="address1"]', function(){
        if($(this).val() && !steco_address.verify($(this), 0))
          $(this).closest('.form-group').addClass('st_po_box_error');
        else
          $(this).closest('.form-group').removeClass('st_po_box_error');
      });
    }
    prestashop.on(
      'steco_event_updated',
      $.proxy(this.initAutocomplete, this)
    );
    prestashop.on(
      'steco_event_updated',
      function(event){
        steco_address.pc_manager();
      }
    );
    prestashop.on(
      'updatedAddressForm',
      $.proxy(this.fillState, this)
    );
    prestashop.on(
      'updatedAddressForm',
      $.proxy(this.initAutocomplete, this)
    );
    prestashop.on(
      'updatedAddressForm',
      function(event){
        if(steasycheckout.disallow_po_box){
          var address_field = event.target.find('input[name="address1"]');
          if(address_field.length){// && address_field.val() wei kong xu yao qu chu st_po_box_error
            if(address_field.val() && !steco_address.verify(address_field, 0))
              address_field.closest('.form-group').addClass('st_po_box_error');
            else
              address_field.closest('.form-group').removeClass('st_po_box_error');
          }
        }
        steco_address.pc_manager();
      }
    );
    prestashop.on(
      'stecoUpdatedAddress',
      $.proxy(this.initAutocomplete, this)
    );
    $(document).on('change', 'input[name="p_or_c"]', function() {
      var _f = $(this).closest('.steco_new_address_form');
      $('.st_form_item_company, .st_form_item_dni', _f).toggleClass('steco_display_none', $('input[name="p_or_c"]:checked', _f).val()==0);
      if(!steasycheckout.show_name_for_company)
        $('.st_form_item_firstname, .st_form_item_lastname', _f).toggleClass('steco_display_none', $('input[name="p_or_c"]:checked', _f).val()==1);
      steco_address.pc_manager();
    });

    $(document).on('click', '.steco_save_info', function(){
      $('.steco_personal_information, .steco_addresses').removeClass('show_incomplete_message show_save_address_message');
      $res = true;
      if(!steco_payment.verify_register(true)){
        $res = false;
        steco_payment.showIncompleteMessage($('.steco_personal_information'));
      }
      if(!steco_payment.verify_addresses(true)){
        $res = false;
        steco_payment.showIncompleteMessage($('.steco_addresses'));
      }
      if($res){
        steco.loading(0);
        steco_address.master();
      }
    });
  },
  'pc_manager': function(){
    if(steasycheckout.person_or_company && $('.steco_new_address_form input[name="p_or_c"]').length){
      $('.steco_new_address_form').each(function(){
        var fields = ['dni', 'company'];
        var fields_b = ['firstname', 'lastname'];
        var that = $(this);
        $.each(fields, function(k,v){
          var _jonny = that.find('input[name="'+v+'"]');
          if(_jonny.length){
            if(that.find('input[name="p_or_c"]:checked').val()==1 && _jonny.data('required')=='1')
              _jonny.prop('required', true);
            else
              _jonny.removeAttr('required');
            if(that.find('input[name="p_or_c"]:checked').val()==1){
              var cv = $.trim(_jonny.data('prev_value'));
              if(!cv && $('#steco_customer_form_register input[name="'+v+'"]').length)
                cv = $('#steco_customer_form_register input[name="'+v+'"]').val();
              _jonny.val(cv);
            }else{
              var cv = _jonny.val();
              _jonny.data('prev_value', cv);
              _jonny.val('');
            }
          }
        });
        $.each(fields_b, function(k,v){
          var _jonny = that.find('input[name="'+v+'"]');
          if(_jonny.length){
            if(that.find('input[name="p_or_c"]:checked').val()==1 && !steasycheckout.show_name_for_company){
              var cv = _jonny.val();
              _jonny.data('prev_value', cv);
              _jonny.val(' ');
            }
            else{
              var cv = $.trim(_jonny.data('prev_value'));
              if(!cv && $('#steco_customer_form_register input[name="'+v+'"]').length)
                cv = $('#steco_customer_form_register input[name="'+v+'"]').val();
              _jonny.val(cv);
            }
          }
        });
      });
    }
  },
  master: function(){
    steco_address.progress();
    if(!steco_address.process.validate_delivery){
      steco_payment.validate_addresses(0, steco_address);
      return true;
    }else if(steco_address.process.validate_delivery==2){
      this.cancle_confirm();
      return true;
    }
    if(!steco_address.process.validate_invoice){
      steco_payment.validate_addresses(1, steco_address);
      return true;
    }else if(steco_address.process.validate_invoice==2){
      this.cancle_confirm();
      return true;
    }
    if(!steco_address.process.pi_submit){
      steco_payment.new_customer(steco_address);
      return true;
    }else if(steco_address.process.pi_submit==2){
      this.cancle_confirm();
      return true;
    }
    if(!steco_address.process.shipping_submit){
      steco_payment.save_address(0, steco_address);
      return true;
    }else if(steco_address.process.shipping_submit==2){
      this.cancle_confirm();
      return true;
    }
    if(!steco_address.process.billing_submit){
      steco_payment.save_address(1, steco_address);
      return true;
    }else if(steco_address.process.billing_submit==2){
      this.cancle_confirm();
      return true;
    }
    $.each(steco_address.process, function(k,v){
      steco_address.process[k]=0;
    });
    steco.update({'item':0});
  },
  progress: function(){
    var percent = 0;
    $.each(steco_address.process, function(k,v){
      if(v==1)
        percent++;
    });
    $('#steco_progress_address').removeClass('steco_display_none').find('.steco_progress_bar').css('width', parseInt(percent/6*100)+'%');
  },
  cancle_confirm: function(){
    $('#steco_progress_address').addClass('steco_display_none');
    steco.loading(false);
    //once an error occurs, start from beginning
    $.each(steco_address.process, function(k,v){
      steco_address.process[k]=0;
    });
    var li = $('.form-group.has-error');
    if(li.length)
      $('body,html').animate({
        scrollTop: li.eq(0).offset().top
      }, 'fast');
  },
  verify: function(element, type){
    var name = element.attr('name'), val=element.val(), required=element.prop('required');
    if(type==1 && element.closest('.eco_af_item').hasClass('eco_af_verify_0'))
      return true;
    if(val!=$.trim(val) && (name=='email' || name=='phone' || name=='postcode')){
      val = $.trim(val);
      element.val(val);
    }
    if(required && !val)
      return false;
    if(!val)
      return true;
    switch(name){
      case 'email':
        return /^[a-zA-Z0-9\._-]+@[a-zA-Z0-9\.-]+\.[a-zA-Z]{2,10}$/.test(val);
      break;
      case 'phone':
        return /^[\(\)\s\-\+\d\.x\#]{5,20}$/.test(val);
      break;
      case 'postcode':
        var postcode_dom = element.parent().find('.postcode_format');
        if (!postcode_dom.length)
            return true;
        var postcode_format = postcode_dom.html();
        if (!postcode_format)
            return true;
        var iso_code = postcode_dom.data('iso_code');

        var zipRegexp = '^'+postcode_format+'$';
        zipRegexp = zipRegexp.replace(/ /g, '( |)');
        zipRegexp = zipRegexp.replace(/-/g, '(-|)');
        zipRegexp = zipRegexp.replace(/N/g, '[0-9]');
        zipRegexp = zipRegexp.replace(/L/g, '[a-zA-Z]');
        if(iso_code)
          zipRegexp = zipRegexp.replace('C', iso_code);
        var reg = new RegExp(zipRegexp);
        return reg.test(val);
      break;
      case 'birthday':
        var date_format_lite = prestashop.language.date_format_lite.toUpperCase().replace('Y','YYYY');
        return moment(val, date_format_lite, true).isValid();
      break;
      case 'firstname':
      case 'lastname':
        return /^[^0-9!<>,;?=+()@#"°{}_$%:¤|]*$/.test(val);
      break;
      case 'address1':
        if(steasycheckout.disallow_po_box){
          var pb_res = /(?:p(?:ost(?:al)?)?[\.\-\s]*(?:(?:o(?:ffice)?[\.\-\s]*)?b(?:ox|in|\b|\d)|o(?:ffice|\b)(?:[-\s]*\d)|code)|box[-\s\b]*\d)/.test(val.toLowerCase());
          return !pb_res;
        }
      break;
    }
    return true;
  },
  initAutocomplete: function()
  {
    if(steasycheckout.gmap_api_key && $('.steco_addresses_form input[name="address1"]').length && typeof(google) != 'undefined' && typeof(google.maps) != 'undefined'){
      this.autocomplete = new google.maps.places.Autocomplete(
          $('.st_address_form_delivery input[name="address1"]')[0],
          {types: ['geocode']});
      if($('.st_address_form_invoice input[name="address1"]').length)
        this.autocomplete_invoice = new google.maps.places.Autocomplete(
            $('.st_address_form_invoice input[name="address1"]')[0],
            {types: ['geocode']});

      this.autocomplete.addListener('place_changed', $.proxy(this.fillInAddress, this, 'delivery'));
      if(this.autocomplete_invoice)
        this.autocomplete_invoice.addListener('place_changed', $.proxy(this.fillInAddress, this, 'invoice'));
      if(steasycheckout.geolocate){
        $(document).on('focus','.st_address_form_delivery input[name="address1"]',$.proxy(this.geolocate, this, 'delivery'));
        if(this.autocomplete_invoice)
          $(document).on('focus','.st_address_form_invoice input[name="address1"]',$.proxy(this.geolocate, this, 'invoice'));
      }
    }
  },

  fillInAddress: function(type) {
    // Get the place details from the autocomplete object.
    var place = type=='delivery' ? this.autocomplete.getPlace() : this.autocomplete_invoice.getPlace();
    var componentForm = {
      // street_number: 'short_name',
      // route: 'long_name',
      sublocality_level_1: 'city',
      locality: 'city',
      administrative_area_level_5: 'id_state',
      administrative_area_level_4: 'id_state',
      administrative_area_level_3: 'id_state',
      administrative_area_level_2: 'id_state',
      administrative_area_level_1: 'id_state',
      country: 'id_country',
      postal_code: 'postcode'
    };
    $.each(componentForm, function(k,v) {
      if(v=='city' || v=='postcode')
        $('.st_address_form_'+type+' [name="'+v+'"]').val('');
    });

    var city = '';
    var postcode = '';
    // Get each component of the address from the place details
    // and fill the corresponding field on the form.
    for (var i = 0; i < place.address_components.length; i++) {
      var addressType = place.address_components[i].types[0];
      if (componentForm[addressType]) {
        var val = place.address_components[i]['long_name'];
        if(componentForm[addressType]=='id_state'){
          this.state_arr.push(val);
        }else if(componentForm[addressType]=='id_country'){
          var country = $('.st_address_form_'+type+' [name="id_country"] option:contains("'+val+'")');
          if(country.length){
            country.prop('selected',true);
            $('.st_address_form_'+type+' .steco-country').trigger('change');
          }
        }else{
          $('.st_address_form_'+type+' [name="'+componentForm[addressType]+'"]').val(val);
          if(componentForm[addressType]=='city')
            city = val;
          if(componentForm[addressType]=='postcode')
            postcode = val;
        }
      }
    }
    if(city){
        var re = new RegExp(', '+city+',.*$');
        var re_a = new RegExp(', '+postcode+' '+city+',.*$');
        var re_b = new RegExp(',.*$');
        if(re.test(place.formatted_address))
          $('.st_address_form_'+type+' input[name="address1"]').val(place.formatted_address.replace(re, ''));
        else if(re_a.test(place.formatted_address))
          $('.st_address_form_'+type+' input[name="address1"]').val(place.formatted_address.replace(re_a, ''));
        else if(re_b.test(place.formatted_address))
          $('.st_address_form_'+type+' input[name="address1"]').val(place.formatted_address.replace(re_b, ''));
    }
  },
  fillState: function() {
    if(this.state_arr.length){
      $.each(this.state_arr, function(k,v){
        var state = $('.steco_addresses_form select[name="id_state"] option:contains("'+v+'")');
        if(state.length){
          state.prop('selected',true);
          return false;
        }
      })
    }
    this.state_arr = [];
  },

  geolocate: function(type) {
    if (navigator.geolocation) {
      navigator.geolocation.getCurrentPosition(function(position) {
        var geolocation = {
          lat: position.coords.latitude,
          lng: position.coords.longitude
        };
        var circle = new google.maps.Circle({
          center: geolocation,
          radius: position.coords.accuracy
        });
        if(type=='delivery')
          steco_address.autocomplete.setBounds(circle.getBounds());
        else
          steco_address.autocomplete_invoice.setBounds(circle.getBounds());
      });
    }
  }
};
function stecoInitAutocomplete(){
  steco_address.initAutocomplete();
}
var steco_delivery = {
  'deliveryFormSelector': '.steco_deliverys_form',
  'cartSelector': '#steco_cart',
  init: function() {
    $(document).on('change', this.deliveryFormSelector + ' .delivery-option :radio', $.proxy(this.updateDeliveryForm, this, {deliveryOpton:true}));
    $(document).on('change', this.deliveryFormSelector + ' .steco-shipping-option', $.proxy(this.updateDeliveryForm, this));
  },
  updateDeliveryForm: function(event) {
    var isDeliveryOpton = typeof(event.deliveryOpton)!=='undefined' && event.deliveryOpton;

    steco.loading(24);
    steco.abortPreviousRequests();

    var $deliveryMethodForm = $(this.deliveryFormSelector);
    var requestData = $deliveryMethodForm.serialize();
    var $inputChecked = $(event.currentTarget);
    var $newDeliveryOption = $(this.deliveryFormSelector + ' .delivery-option :radio:checked').parents("div.delivery-option");

    if(isDeliveryOpton){
      $('.delivery-option').removeClass('steco_selected steco-input-loading');
      $newDeliveryOption.addClass('steco_selected steco-input-loading');
    }
    $.ajax(
    {
        type: 'POST',
        url: $deliveryMethodForm.data('url-update'),
        data: requestData,
        dataType: 'json',
        cache: false,
        beforeSend: function (jqXHR) {
          steco.promises.push(jqXHR);
        }
    }).then(function (resp) {
      steco.loading(false);
      steco.update_dom(resp);
      prestashop.emit('updatedDeliveryForm', {
        dataForm: $deliveryMethodForm.serializeArray(),
        deliveryOption: $newDeliveryOption,
        resp: resp
      });
      if(isDeliveryOpton)
        $('.delivery-option').removeClass('steco-input-loading');
    }).fail(function (resp) {
      prestashop.emit('stecoHandleError', {eventType: 'updateDeliveryOptions', resp: resp}); 
      steco.loading(false);
      if(isDeliveryOpton)
        $('.delivery-option').removeClass('steco-input-loading');
    });
  },
  'getSelectedDeliveryContainer': function(){
    return $(steco_delivery.deliveryFormSelector + ' .delivery-option :radio:checked').parents("div.delivery-option").parent();
  },
  'colissimo': function(){
    var slectedDeliveryOption = steco_delivery.getSelectedDeliveryContainer();
    if(slectedDeliveryOption.find('.colissimo-pickup-point-address').length){
      var pickup_point = slectedDeliveryOption.find('input[name="id_colissimo_pickup_point"]');
      if(!pickup_point.length || pickup_point.val()=='')
        return false;
      var phone = slectedDeliveryOption.find('#colissimo-pickup-mobile-phone');
      if(!phone.length || phone.val()=='' || phone.val().indexOf('_') != -1)
        return false;
    }    
    return true;
  },
  'colissimo_relais': function(){
    var slectedDeliveryOption = steco_delivery.getSelectedDeliveryContainer();
    return slectedDeliveryOption.find('.colissimo-pickup-point-address').length;
  },
  'colissimo_get_mobile_phone': function(){
    var slectedDeliveryOption = steco_delivery.getSelectedDeliveryContainer();
    return slectedDeliveryOption.find('#colissimo-pickup-mobile-phone').val();
  }
};
var steco_payment = {
  confirmationSelector: '#payment-confirmation',
  paymentSelector: '#payment-section',
  conditionsSelector: '#steco-conditions-to-approve',
  conditionAlertSelector: '.js-alert-payment-conditions',
  additionalInformatonSelector: '.js-additional-information',
  optionsForm: '.js-payment-option-form',
  paymentOptionsSelector: '.steco-payment-option',
  process: {
    'validate_delivery': 0,
    'validate_invoice': 0,
    'pi_submit': 0,
    'shipping_submit': 0,
    'billing_submit': 0,
    'delivery_submit': 0,
    'colissimo': 0,
    'stripejs_new': 0,
    'payline': 0,
    'ddw': 0,
    'delivery_message_submit': 0
      
  },
  format: {'prefix':'', 'suffix':'','symbles':[], 'sample':'', 'decimals':2},
  init: function(){

    this.learnFormat();
    $(this.paymentSelector + ' input[type="checkbox"][disabled]').attr('disabled', false);

    $(document).on('change', this.conditionsSelector + ' input[type="checkbox"]', $.proxy(this.toggleOrderButton, this));
    $(document).on('change', this.paymentOptionsSelector + ' input[name="payment-option"]', $.proxy(this.toggleOrderButton, this, {select_payment_method:true}));
    $(document).on('click', this.confirmationSelector + ' .steco_confirmation_btn', $.proxy(this.toggleOrderButton, this, {complete:true}));
    $(document).on('click', this.confirmationSelector + ' button', $.proxy(this.confirm, this));
    // $(document).on('click', this.confirmationSelector + ' button[type="button"]', $.proxy(this.confirm, this));

    prestashop.on(
      'steco_event_updated',
      $.proxy(this.toggleOrderButton, this)
    );
    prestashop.on(
      'steco_payment_master_error',
      $.proxy(this.cancle_confirm, this)
    );
    // this.collapseOptions();
  },
  everything_is_ready: function(yn){
    if(yn)
      $(this.confirmationSelector + ' button').removeAttr('disabled');
    else
      $(this.confirmationSelector + ' button').attr('disabled', 'disabled');
  },
  collapseOptions: function(){
    $(this.additionalInformatonSelector + ', ' + this.optionsForm).hide();
  },
  getSelectedOption: function(){
    return $(this.paymentOptionsSelector + ' input[name="payment-option"]:checked').attr('id');
  },
  hideConfirmation: function(){
    $(this.confirmationSelector).hide();
  },
  showConfirmation: function(){
    $(this.confirmationSelector).show();
  },
  selectPaymentMethod: function(){
    $('.steco_payment').removeClass('show_incomplete_message');
    var selectedOption = $(this.paymentOptionsSelector + ' input[name="payment-option"]:checked');
        $.ajax({
          url: steasycheckout.urls.select_payment_method,
          method: 'POST',
          dataType: 'json',
          data: {
              select_payment_option: selectedOption.attr('id'),
              select_payment_module: selectedOption.data('module-name'),
          },
          cache: false,
          beforeSend: function (jqXHR) {
            steco.promises.push(jqXHR);
          }
        }).then(function (resp) {
           
        }).fail(function(resp) {
          prestashop.emit('stecoHandleError', {eventType: 'selectPaymentMethod', resp: resp});          
        });
  },
  handle_payment_fee: function(){
    var selectedOption = this.getSelectedOption();
    if(!selectedOption){
      steco_payment.hide_payment_fee();
      return;  
    }
    var addtional_infomation = $('#' + selectedOption + '-additional-information');
    var container = $('#' + selectedOption + '-container');
    var payment_form = $('#pay-with-' + selectedOption + '-form .payment-form');
    if(payment_form.length && payment_form.attr('action').indexOf('megareembolso') != -1 && addtional_infomation.find('dl').length){//megareembolso
      var megareembolso_fee = addtional_infomation.find('dd:first').html();
      var megareembolso_int_fee = parseFloat(this.deFormatPrice(megareembolso_fee),10);
      var megareembolso_int_total = parseFloat($('.cart-summary-totals .cart-total span.value').data('amount'), 10);
      this.show_payment_fee(addtional_infomation.find('dt:first').html(), megareembolso_fee, this.formatPrice(megareembolso_int_fee+megareembolso_int_total), false);
    }else if(addtional_infomation.find('#paypal_fee').length){//paypal aw
      var paypal_fee = parseFloat(addtional_infomation.find('#paypal_fee').html(), 10);
      this.show_payment_fee(false, (paypal_fee.toFixed(2).replace('.',',')+ ' ' + prestashop.currency.sign), ((paypal_fee + parseFloat($('.cart-summary-totals .cart-total span.value').data('amount'), 10)).toFixed(2).replace('.',',')+ ' ' + prestashop.currency.sign),false);
    }else if($('#'+selectedOption).data('module-name') == "codpro" && typeof(cart_total_codfee)!='undefined'){//codpro
      this.show_payment_fee(false,cart_shipping_codfee, cart_total_codfee,cart_subtotal_tax_codfee);
   }else if($('#'+selectedOption).data('module-name') == "codfee"){//codfee
      var codfee_id = $("input[name='codfee_id']", payment_form).val();
      if($("input[name='codfee_text']").length)
        this.show_payment_fee($("input[name='codfee_text']").val(),$("input[name='codfee_fee']").val(), $("input[name='codfee_total']").val(),($("input[name='codfee_tax_enabled']").val() == '1' && $("input[name='codfee_tax_display']").val() == '1' ? $("input[name='codfee_taxes']").val() : false));
      else if($("input[name='codfee_text_"+codfee_id+"']").length)
        this.show_payment_fee($("input[name='codfee_text_"+codfee_id+"']").val(),$("input[name='codfee_fee_"+codfee_id+"']").val(), $("input[name='codfee_total_"+codfee_id+"']").val(),($("input[name='codfee_tax_enabled_"+codfee_id+"']").val() == '1' && $("input[name='codfee_tax_display_"+codfee_id+"']").val() == '1' ? $("input[name='codfee_taxes_"+codfee_id+"']").val() : false));
    }else if(payment_form.length && payment_form.attr('action').indexOf('dm_cashondelivery') != -1 && container.find('.steco_payment_option_title').html().split('+').length==2){//dm_cashondelivery
      var dm_fee = container.find('.steco_payment_option_title').html().split('+');
      var dm_int_fee = parseFloat(this.deFormatPrice($.trim(dm_fee[1])),10);
      var dm_int_total = parseFloat($('.cart-summary-totals .cart-total span.value').data('amount'), 10);
      this.show_payment_fee($.trim(dm_fee[0]), $.trim(dm_fee[1]), this.formatPrice(dm_int_fee+dm_int_total), false);
    }else if($('#'+selectedOption).data('module-name') == "idxcodfees" && addtional_infomation.find('#pricecodfees').length){//idxcodfees
      var idx_fee = addtional_infomation.find('#feecodfee').html();
      var idx_shipping = $('#cart-subtotal-shipping .value').html();
      var idx_int_fee = parseFloat(this.deFormatPrice(idx_fee), 10);
      var has_shipping_fee = /\d/.test(idx_shipping);
      if(has_shipping_fee)
        var idx_int_shipping = parseFloat(this.deFormatPrice(idx_shipping), 10);
      else
        var idx_int_shipping = 0;
      this.show_payment_fee(container.find('.steco_payment_option_title').html(), this.formatPrice(idx_int_fee-idx_int_shipping), addtional_infomation.find('#pricecodfees').html(), false);
    }else if(typeof(label_payment_fee)!='undefined'){
      var $id_payment_method = 0;
      var $payment_option = $('#'+selectedOption).attr('id');
      $.ajax({
        url: '',
        data: 'ets_set_payment_option=1&module_name='+$('#'+selectedOption).data('module-name')+'&id_payment_method='+$id_payment_method+'&payment_option='+$payment_option,
        type: 'post',
        dataType: 'json',
        success: function(json){   
          if(json.payment_fee){
            steco_payment.show_payment_fee(label_payment_fee, json.payment_fee, json.total_cart, false);
            if($('#'+$payment_option+'-additional-information').length)
            {
                if($('#'+$payment_option+'-additional-information .payment_fee').length==0)
                    $('#'+$payment_option+'-additional-information').append('<section class="payment_fee"><dl><dt>'+label_payment_fee+' '+json.text_percentage+'</dt><dd class="fee">'+json.payment_fee+'</dd></dl></section>');
                else
                    $('#'+$payment_option+'-additional-information .payment_fee .fee').html(json.payment_fee);
            }
          }
          else{
            steco_payment.hide_payment_fee();
            if($('#'+$payment_option+'-additional-information .payment_fee').length)
              $('#'+$payment_option+'-additional-information .payment_fee').remove();
          }
        }
      });
    }else if($('#'+selectedOption).data('module-name') == "codwfeeplus" && addtional_infomation.find('#codwfeeplus_payment_infos').length){//codwfeeplus
      var _url = $("#codwfeeplus_payment_infos").attr("data-ajaxurl");
      $.ajax({
          type: 'POST',
          url: _url,
          data: {cod_active: 1},
          success: function (data) {
              if (typeof data !== "undefined") {
                var $data = $($.parseHTML(data.preview));
                steco_payment.show_payment_fee($data.find('#cart-subtotal-cod_fee .label').text(), $data.find('#cart-subtotal-cod_fee .price').text(), $data.find('.cart-total .price').text(), typeof(data.subtotals_tax)!='undefined' && data.subtotals_tax ? data.subtotals_tax : false);
              }
          },
          error: function (data) {
          }
      });
    }else if($('#'+selectedOption).data('module-name') == "paypalwithfee" && addtional_infomation.find('#ppalwf_fee').length && addtional_infomation.find('#ppalwf_fee').attr('no_fee')=='false'){
      steco_payment.show_payment_fee($('#ppalwf_tfee').text(), $('#ppalwf_fee').text(), $('#ppalwf_total').text(), false);
    }else if($('#'+selectedOption).data('module-name') == "cashondeliveryplus" && typeof(cashondeliveryplus_codfee)!='undefined'){
      steco_payment.show_payment_fee('', cashondeliveryplus_codfee, cashondeliveryplus_total_price_cod, false);
    }else{
      steco_payment.hide_payment_fee();
    }
    return;  
  },
  show_payment_fee: function(_label,fee,total,sub){
    $('.cart-summary-st-fee').removeClass('steco_display_none').find('.value').html(fee); 
    $('.cart-summary-st-fee').find('.label').html(_label ? _label : $('.cart-summary-st-fee .label').data('label'));    
    $('.cart-summary-totals .cart-total span.value').html(total);
    if(sub)
      $('.cart-summary-totals span.sub.value').html(sub);
  },
  hide_payment_fee: function(){
    $('.cart-summary-st-fee').addClass('steco_display_none').find('.label').html($('.cart-summary-st-fee .label').data('label'));
    $('.cart-summary-totals .cart-total span.value').html($('.cart-summary-totals .cart-total span.value').data('total'));
    $('.cart-summary-totals span.sub.value').html($('.cart-summary-totals span.sub.value').data('total'));
  },
  learnFormat: function(){
        var reg = new RegExp("^([^\\d]*).*?([^\\d]*)$");
        var sample = steasycheckout.price;
        var new_sample = steasycheckout.price;
        var res = reg.exec(sample);
        if(res){
            if(res[1]){
                steco_payment.format.prefix = res[1];
                new_sample = new_sample.replace(res[1],'');
            }
            if(res[2]){
                steco_payment.format.suffix = res[2];
                new_sample = new_sample.replace(res[2],'');
            }
        }
        var reg = /([^\d])?(\d+)/g;
        var match;
        while (match = reg.exec(new_sample)) {
            steco_payment.format.symbles.unshift({'change':(''+match[2]).length,'symble':match[1]?match[1]:''})
        }
            var reg = new RegExp("[123]",'g');
            var d_arr = sample.match(reg);
            steco_payment.format.decimals = d_arr.length-3;
    },
    formatPrice: function(value){
        if(!steco_payment.format.symbles.length)
            return value;
        if(value==0)
            return steco_payment.format.prefix+'0'+steco_payment.format.suffix;
        
        value = value.toFixed(steco_payment.format.decimals).toString().replace(/([^\d]+)/g,'');
        var price_arr = value.split('').reverse();

        var price_new = '';
        var index = 0;
        $.each(steco_payment.format.symbles, function(k,v){
            for (var i = 0; i < v.change; i++) { 
                if(index<price_arr.length)
                    price_new = price_arr[index++]+price_new;
                else
                    break;
            }
            if(index<price_arr.length)
                price_new = v.symble+price_new;
        });
        if(index<price_arr.length)
            for (var j=index; j < price_arr.length; j++) {
                price_new = price_arr[j]+price_new;
            }
        return steco_payment.format.prefix+price_new+steco_payment.format.suffix;
    },
    deFormatPrice: function(value){
        value = value.toString().replace(steco_payment.format.prefix,'');
        value = value.replace(steco_payment.format.suffix,'');
        if(steco_payment.format.decimals)
        {
            var value_arr = value.split(steco_payment.format.symbles[0].symble);
            if(value_arr.length>1){
                var decimal = value_arr.pop();
                value = value_arr.join('').replace(/([^\d]+)/g,'')+'.'+decimal;
            }else{
                value = value.replace(/([^\d]+)/g,'');
            }
        }
        else
            value = value.replace(/([^\d]+)/g,'');
        return value;
    },
  toggleOrderButton: function(params) {
    this.handle_payment_fee();

    var complete = typeof(params.complete)!=='undefined' && params.complete;
    if(complete){
      if($(this.confirmationSelector + ' .steco_confirmation_btn').hasClass('steco_disabled'))
        return false;
      $('.show_incomplete_message').removeClass('show_incomplete_message show_save_address_message show_terms_conditions_message_only  show_terms_conditions_message_all');
    }

    if(typeof(params.select_payment_method)!=='undefined' && params.select_payment_method)
      this.selectPaymentMethod();

    $(this.paymentOptionsSelector + ' label').removeClass('steco_selected');
    $(this.paymentOptionsSelector + ' input[name="payment-option"]:checked').closest('label').addClass('steco_selected');

    var show = true;

    if(!steco_delivery.colissimo()){
        show = false;
        if(complete)
          steco_payment.showIncompleteMessage($('.steco_delivery'));
    }

    this.collapseOptions();

    var selectedOption = this.getSelectedOption();
    if (!selectedOption) {
      show = false;
      //
      if(complete && (!steasycheckout.model || $('#st-checkout-personal-information-step.steco-is_logged').length))//
        steco_payment.showIncompleteMessage($('.steco_payment'));
    }
    if($('#'+selectedOption).data('module-name')=='paypalplus' && $("#pppContinueButton").prop('disabled')){
      show = false;
      if(complete)
        steco_payment.showIncompleteMessage($('.steco_payment'));
    }

    $(this.conditionsSelector + ' input[type="checkbox"]').each(function(_, checkbox) {
      if (!checkbox.checked) {
        show = false;
        if(complete){
          if(steasycheckout.terms_conditions_position){
            $('.steco_payment').addClass($('.steco_payment').hasClass('show_incomplete_message') ? 'show_terms_conditions_message_all' : 'show_terms_conditions_message_only');
            steco_payment.showIncompleteMessage($('.steco_payment'));
          }else{
            $('.steco_cart').addClass($('.steco_cart').hasClass('show_incomplete_message') ? 'show_terms_conditions_message_all' : 'show_terms_conditions_message_only');
            steco_payment.showIncompleteMessage($('.steco_cart'));
          }
        }
      }
    });

    var incomplete = $('.steco-step.steco-incomplete');
    if(incomplete.length){
      $.each(incomplete,function(){
        if($(this).attr('id')=="st-checkout-personal-information-step" && $('input[name=steco_pi_form]:checked').val()==1 && steco_payment.verify_register(complete)){
            return true;
        }
        /*ecoAjaxAddressForm chuan jian di zhi daozhi yong yuan wei complete
        *dang dizhiye you bi tian zhiduan de shihou incomplete, daozhi meifa tian jia di zhi*/
        if($(this).attr('id')=="st-checkout-addresses-step" && ($('input[name=steco_pi_form]:checked').val()==1 || $('#st-checkout-personal-information-step.steco-is_logged').length) && steco_payment.verify_addresses(complete)){
            return true;
        }
        /*if($(this).attr('id')=="st-checkout-delivery-step"){
            return true;//mu qian zhi you colissimo shi yong le isModuleComplete
        }*/
        show = false;
        if(complete)
          steco_payment.showIncompleteMessage($(this).closest('.steco_block'));
      });
    }
    if(!$('.steco_addresses').hasClass('steco_display_none') && $('.st_address_form_delivery').length && !steco_payment.verify_addresses(complete)){
      show = false;
      if(complete)
        steco_payment.showIncompleteMessage($('.steco_addresses'));
    }
    if($('#st-checkout-personal-information-step.steco-is_logged.steco-is_guest').length && !steco_payment.verify_register(complete)){
      show = false;
      if(complete)
        steco_payment.showIncompleteMessage($('.steco_personal_information'));
    }
    if($('#st-checkout-personal-information-step.steco-is_logged.steco-is_guest').length && !steco_payment.verify_addresses(complete)){
      show = false;
      if(complete)
        steco_payment.showIncompleteMessage($('.steco_addresses'));
    }
    //if edit/add address forum is open
    if($('#st-checkout-personal-information-step.steco-is_logged').length && !$('#st-checkout-personal-information-step.steco-is_logged').hasClass('steco-is_guest') && $('.steco_addresses_from.steco_display_none').length && (steasycheckout.model || (!steasycheckout.model && $('#delivery-addresses').length))){//yijing denglu er qie you di zhi
      show = false;
      if(complete){
        var $steco_addresses = $('.steco_addresses');
        if(!$steco_addresses.hasClass('show_incomplete_message'))
          $steco_addresses.addClass('show_save_address_message');
        steco_payment.showIncompleteMessage($steco_addresses);
      }
    }

    if(steasycheckout.model && complete){
      if(!$('#st-checkout-personal-information-step.steco-is_logged').length){
        show = false;
        $('.steco_addresses').addClass('show_save_address_message');
        steco_payment.showIncompleteMessage($('.steco_addresses'));
      }
    }

    $('#' + selectedOption + '-additional-information').show();
    $('#pay-with-' + selectedOption + '-form').show();

    $('.js-payment-binary').hide();
    if ($('#' + selectedOption).hasClass('binary')) {
      var paymentOption = this.getPaymentOptionSelector(selectedOption);
      this.hideConfirmation();
      $(paymentOption).show();

      if (show) {
        $(paymentOption).removeClass('disabled');
      } else {
        $(paymentOption).addClass('disabled');
      }
    } else {
      this.showConfirmation();
      // $(this.confirmationSelector + ' button[type="submit"]').attr('disabled', !show).toggleClass('steco_display_none', !show);
      // $(this.confirmationSelector + ' .steco_confirmation_btn').toggleClass('steco_display_none', show);
      steco_payment.everything_is_ready(show);
      if (show) {
        $(this.conditionAlertSelector).hide();
      } else {
        $(this.conditionAlertSelector).show();
      }
      if(show && complete){
        this.pre_confirm();
      }
    }
    return show;
  },
  verify_register: function(complete){
    var validate = this.validate_required_fields($('#steco_customer_form_register :input[required]'),complete);
    if(!validate)
      return validate;
    validate &= steco_address.verify($('#steco_customer_form_register input[name="email"]'),0);
    $('#steco_customer_form_register input[name="email"]').closest('.form-group ').toggleClass('st-has-error', !validate);
    if(!validate)
      return validate;
    if($('#steco_customer_form_register input[name="birthday"]').length){
      validate &= steco_address.verify($('#steco_customer_form_register input[name="birthday"]'),0);
      $('#steco_customer_form_register input[name="birthday"]').closest('.form-group ').toggleClass('st-has-error', !validate);
      if(!validate)
        return validate;
    }
    if($('#steco_customer_form_register input[name="steco_psgdpr_consent_checkbox"]').length){
      validate &= $('#steco_customer_form_register input[name="steco_psgdpr_consent_checkbox"]').prop('checked');
      $('#steco_customer_form_register input[name="steco_psgdpr_consent_checkbox"]').closest('.form-group ').toggleClass('st-has-error', !validate);
      if(!validate)
        return validate;
    }
    /*var bd = new Date($('#steco_customer_form_register .st_form_item_birthday select[name="stbirthday[Year]"]').val()+'-'+$('#steco_customer_form_register .st_form_item_birthday select[name="stbirthday[Month]"]').val()+'-'+$('#steco_customer_form_register .st_form_item_birthday select[name="stbirthday[Day]"]').val())
    var today = new Date();
    if(bd.getTime()>=new Date(today.getFullYear()-18, today.getMonth(), today.getDate(), 0, 0, 0)){
      $('#steco_customer_form_register .st_form_item_birthday').toggleClass('st-has-error', true);
      return false;
    }*/
    var bs = $('#steco_customer_form_register .st_form_item_birthday select');
    if(bs.length){
      bs.each(function(){
        if(!$(this).val()){
          validate = false;
          return false;
        }
      });
      // $('#steco_customer_form_register .st_form_item_birthday').toggleClass('has-error', !validate);
      $('#steco_customer_form_register .st_form_item_birthday').toggleClass('st-has-error', !validate);
      if(!validate){
        return validate;
      }
    }
    return validate;
  },
  verify_addresses: function(complete){
    var validate = this.validate_required_fields($('.st_address_form_delivery .steco_new_address_form :input[required]'),complete);
    if(!validate)
      return validate;
    validate &= steco_address.verify($('.st_address_form_delivery .steco_new_address_form input[name="phone"]'),1);
    $('.st_address_form_delivery .steco_new_address_form input[name="phone"]').closest('.form-group ').toggleClass('st-has-error', !validate);
    if(!validate)
      return validate;
    validate &= steco_address.verify($('.st_address_form_delivery .steco_new_address_form input[name="postcode"]'),1);
    $('.st_address_form_delivery .steco_new_address_form input[name="postcode"]').closest('.form-group ').toggleClass('st-has-error', !validate);
    if(!validate)
      return validate;
    validate &= steco_address.verify($('.st_address_form_delivery .steco_new_address_form input[name="firstname"]'),1);
    $('.st_address_form_delivery .steco_new_address_form input[name="firstname"]').closest('.form-group ').toggleClass('st-has-error', !validate);
    if(!validate)
      return validate;
    validate &= steco_address.verify($('.st_address_form_delivery .steco_new_address_form input[name="lastname"]'),1);
    $('.st_address_form_delivery .steco_new_address_form input[name="lastname"]').closest('.form-group ').toggleClass('st-has-error', !validate);
    if(!validate)
      return validate;
    validate &= steco_address.verify($('.st_address_form_delivery .steco_new_address_form input[name="address1"]'), (steasycheckout.disallow_po_box ? 0 : 1));
    $('.st_address_form_delivery .steco_new_address_form input[name="address1"]').closest('.form-group ').toggleClass((steasycheckout.disallow_po_box ? 'st_po_box_error' : 'st-has-error'), !validate);
    if(!validate)
      return validate;
    if(steasycheckout.person_or_company){
      if($('.st_address_form_delivery .steco_new_address_form input[name="p_or_c"]:checked').val()==1){
        if($.trim($('.st_address_form_delivery .steco_new_address_form input[name="company"]').val())==''){
          validate = false;
        }
        $('.st_address_form_delivery .steco_new_address_form input[name="company"]').closest('.form-group ').toggleClass('has-error', !validate);
        if($('.st_address_form_delivery .steco_new_address_form input[name="dni"]').length){
          if($.trim($('.st_address_form_delivery .steco_new_address_form input[name="dni"]').val())==''){
            validate = false;
          }
          $('.st_address_form_delivery .steco_new_address_form input[name="dni"]').closest('.form-group ').toggleClass('has-error', !validate);
        }
      }else{
          $('.st_address_form_delivery .steco_new_address_form input[name="company"]').closest('.form-group ').removeClass('has-error');
          $('.st_address_form_delivery .steco_new_address_form input[name="dni"]').closest('.form-group ').removeClass('has-error');
      }
      if(!validate)
        return validate;
    }

    if($('.st_address_form_delivery input[name="show_invoice_button"]').length && !$('.st_address_form_delivery input[name="show_invoice_button"]').prop('checked')){
      validate &= this.validate_required_fields($('.st_address_form_invoice .steco_new_address_form :input[required]'),complete);
      if(!validate)
        return validate;
      validate &= steco_address.verify($('.st_address_form_invoice .steco_new_address_form input[name="phone"]'),1);
      $('.st_address_form_invoice .steco_new_address_form input[name="phone"]').closest('.form-group ').toggleClass('st-has-error', !validate);
      if(!validate)
        return validate;
      validate &= steco_address.verify($('.st_address_form_invoice .steco_new_address_form input[name="postcode"]'),1);
      $('.st_address_form_invoice .steco_new_address_form input[name="postcode"]').closest('.form-group ').toggleClass('st-has-error', !validate);
      if(!validate)
        return validate;
      validate &= steco_address.verify($('.st_address_form_invoice .steco_new_address_form input[name="firstname"]'),1);
      $('.st_address_form_invoice .steco_new_address_form input[name="firstname"]').closest('.form-group ').toggleClass('st-has-error', !validate);
      if(!validate)
        return validate;
      validate &= steco_address.verify($('.st_address_form_invoice .steco_new_address_form input[name="lastname"]'),1);
      $('.st_address_form_invoice .steco_new_address_form input[name="lastname"]').closest('.form-group ').toggleClass('st-has-error', !validate);
      if(!validate)
        return validate;
      validate &= steco_address.verify($('.st_address_form_invoice .steco_new_address_form input[name="address1"]'), (steasycheckout.disallow_po_box ? 0 : 1));
      $('.st_address_form_invoice .steco_new_address_form input[name="address1"]').closest('.form-group ').toggleClass((steasycheckout.disallow_po_box ? 'st_po_box_error' : 'st-has-error'), !validate);
      if(!validate)
        return validate;
      if(steasycheckout.person_or_company){
        if($('.st_address_form_invoice .steco_new_address_form input[name="p_or_c"]:checked').val()==1){
          if($.trim($('.st_address_form_invoice .steco_new_address_form input[name="company"]').val())==''){
            validate = false;
          }
          $('.st_address_form_invoice .steco_new_address_form input[name="company"]').closest('.form-group ').toggleClass('has-error', !validate);
          if($('.st_address_form_invoice .steco_new_address_form input[name="dni"]').length){
            if($.trim($('.st_address_form_invoice .steco_new_address_form input[name="dni"]').val())==''){
              validate = false;
            }
            $('.st_address_form_invoice .steco_new_address_form input[name="dni"]').closest('.form-group ').toggleClass('has-error', !validate);
          }
        }else{
            $('.st_address_form_invoice .steco_new_address_form input[name="company"]').closest('.form-group ').removeClass('has-error');
            $('.st_address_form_invoice .steco_new_address_form input[name="dni"]').closest('.form-group ').removeClass('has-error');
        }
        if(!validate)
          return validate;
      }
    }
    return validate;
  },
  validate_required_fields: function(required_fields,complete){
    var res = true;
    $.each(required_fields, function(){
      if(!$(this).val() && $(this).val()!==0 && $(this).val()!=='0'){
        res = false;
        if(complete){
          $(this).closest('.form-group').addClass('has-error');
          if($(this).closest('.eco_af_item').length){
            if($(this).closest('.eco_af_item').hasClass('eco_af_verify_1'))
              $(this).closest('.form-group ').addClass('st-has-error');//st-has-error
          }
          else
            $(this).closest('.form-group').addClass('st-has-error');
        }
      }else{
        $(this).closest('.form-group').removeClass('has-error st-has-error');
      }
    });
    return res;
  },
  showIncompleteMessage: function(dom){
    if(!dom.length)
      return false;
    dom.addClass('show_incomplete_message');
    $('body,html').animate({
      scrollTop: $('.show_incomplete_message:first').offset().top
    }, 'fast');
  },
  getPaymentOptionSelector: function(option){
    var moduleName = $('#'+option).data('module-name');

    return '.js-payment-'+moduleName;
  },
  pre_confirm: function(){
    /*if(!this.toggleOrderButton({complete:true}))
      return false;*/
    var option = this.getSelectedOption();
    if(!steasycheckout.stop_overlay)
      steco.loading(0);
    if($('#st-checkout-personal-information-step.steco-is_logged').length && !$('#st-checkout-personal-information-step').hasClass('steco-is_guest')){
      var _has_address = $('.steco_addresses_from #delivery-addresses').length;//!steasycheckout.model || 
      if(_has_address){
      this.process.validate_delivery=1;
      this.process.validate_invoice=1;
      }
      this.process.pi_submit=1;
      if(_has_address){
      this.process.shipping_submit=1;
      this.process.billing_submit=1;
      }
      // this.process.delivery_submit=1; //carrier keyi xuan shijian de qingkong, tiao jiao de shihou yao bao chun cai xing
    }
    if(steco_delivery.colissimo_relais())
      this.process.colissimo=0;
    else
      this.process.colissimo=1;
    if($('#'+option).data('module-name')=='stripejs-new')
      this.process.stripejs_new=0;
    else
      this.process.stripejs_new=1;
    if($('#'+option).data('module-name')=='payline')
      this.process.payline=0;
    else
      this.process.payline=1;
    if(typeof(ddw)!='undefined')
      this.process.ddw=0;
    else
      this.process.ddw=1;
    this.master();
  },
  cancle_confirm: function(){
    $('#steco_progress_payment').addClass('steco_display_none');
    steco.loading(false);
    steco_payment.everything_is_ready(false);
    //once an error occurs, start from beginning
    $.each(steco_payment.process, function(k,v){
      steco_payment.process[k]=0;
    });
    //php form error
    var li = $('.form-group.has-error,.stripe-error-message');
    if(li.length)
      $('body,html').animate({
        scrollTop: li.eq(0).offset().top-100
      }, 'fast');
  },
  master: function(){
    this.progress();
    if(!this.process.ddw){
      this.check_ddw();
      return true;
    }else if(this.process.ddw==2){
      this.cancle_confirm();
      return true;
    }
    if(!this.process.validate_delivery){
      this.validate_addresses(0, steco_payment);
      return true;
    }else if(this.process.validate_delivery==2){
      this.cancle_confirm();
      return true;
    }
    if(!this.process.validate_invoice){
      this.validate_addresses(1, steco_payment);
      return true;
    }else if(this.process.validate_invoice==2){
      this.cancle_confirm();
      return true;
    }
    if(!this.process.pi_submit){
      this.new_customer(steco_payment);
      return true;
    }else if(this.process.pi_submit==2){
      this.cancle_confirm();
      return true;
    }
    if(!this.process.shipping_submit){
      this.save_address(0, steco_payment);
      return true;
    }else if(this.process.shipping_submit==2){
      this.cancle_confirm();
      return true;
    }
    if(!this.process.billing_submit){
      this.save_address(1, steco_payment);
      return true;
    }else if(this.process.billing_submit==2){
      this.cancle_confirm();
      return true;
    }
    if(!this.process.delivery_submit){
      this.save_delivery();
      return true;
    }else if(this.process.delivery_submit==2){
      this.cancle_confirm();
      return true;
    }
    if(!this.process.colissimo){
      this.save_colissimo();
      return true;
    }else if(this.process.colissimo==2){
      this.cancle_confirm();
      return true;
    }
    if(!this.process.stripejs_new){
      this.get_address_info();
      return true;
    }else if(this.process.stripejs_new==2){
      this.cancle_confirm();
      return true;
    }
    if(!this.process.payline){
      this.reload_payments_for_payline();
      return true;
    }else if(this.process.payline==2){
      this.cancle_confirm();
      return true;
    }
    if(!this.process.delivery_message_submit){
      this.save_delivery_message();
      return true;
    }else if(this.process.delivery_message_submit==2){
      this.cancle_confirm();
      return true;
    }
    var option = this.getSelectedOption();
    var module_name = '';
    if (option)
      module_name = $('#'+option).data('module-name');
    if(steasycheckout.payments_no_submit && module_name){
      if((steasycheckout.payments_no_submit+',').indexOf((module_name+',')) != -1){
        prestashop.emit('steco_submit_confirm', {});
        return false;
      }
    }
    $(this.confirmationSelector + ' button').trigger('click');
    // this.confirm();
  },
  progress: function(){
    var percent = 0;
      this.process.validate_delivery==1 && percent++;
      this.process.validate_invoice==1 && percent++;
      this.process.pi_submit==1 && percent++;
      this.process.shipping_submit==1 && percent++;
      this.process.billing_submit==1 && percent++;
      this.process.delivery_submit==1 && percent++;
      this.process.colissimo==1 && percent++;
      this.process.stripejs_new==1 && percent++;
      this.process.payline==1 && percent++;
      this.process.ddw==1 && percent++;
      this.process.delivery_message_submit==1 && percent++;
      $('#steco_progress_payment').removeClass('steco_display_none').find('.steco_progress_bar').css('width', parseInt(percent/12*100)+'%');
  },
  new_customer: function(x){
      var $form = $('#steco_customer_form_register');
      if(!$form.length){
        x.process.pi_submit = 1;
        x.master();
        return;
      }
      if($form.find('input[name="steco_psgdpr_consent_checkbox"]').length){
        steco.gdprLog($form.find('input[name="steco_psgdpr_consent_checkbox"]'));
      }
      $form.find('.form-footer .steco-btn-spin').addClass('active');
      // steco.loading(0);
      var _birthday = [];
      var bs = $form.find('.st_form_item_birthday select');
      if(bs.length){
        bs.each(function(){
          _birthday.push($(this).val());
        });
      }
      $.ajax(
      {
          type: 'POST',
          url: $form.attr('action') + '&items=1&final=1',
          data: $form.serialize()+(_birthday.length?'&birthday='+_birthday.join(prestashop.language.date_format_lite.indexOf('-') != -1 ? '-' : '/'):''),
          dataType: 'json',
          cache: false
      }).then(function (resp) {
        // steco.loading(false);
        // steco.update_dom(resp);
        if(resp.is_logged && !resp.has_error){
          x.process.pi_submit = 1;
        }else{
          x.process.pi_submit = 2;
          steco.update_dom(resp);
        }
        x.master();
        //
      }).fail(function (resp) {
        prestashop.emit('steco_payment_master_error', {eventType: 'authentication', resp: resp});
      });
  },
  validate_addresses: function(type, x){
    var formSelector = type ? '.st_address_form_invoice' : '.st_address_form_delivery';
    var $form = $(formSelector + ' .steco_new_address_form');
      $.ajax(
      {
          type: 'POST',
          url: steasycheckout.urls.validate_address+'&delivery_invoice='+$form.find('input[name="saveAddress"]').val(),
          data: $form.serialize(),
          dataType: 'json',
          cache: false
      }).then(function (resp) {
        if(!resp.r){
          if(type)
            x.process.validate_invoice = 2;
          else
            x.process.validate_delivery = 2;
          $(formSelector).replaceWith(resp.address_form);
        }else{
          if(type)
            x.process.validate_invoice = 1;
          else{
            x.process.validate_delivery = 1;
            if($form.find('input[name="show_invoice_button"]').prop('checked'))
              x.process.validate_invoice = 1;
          }
        }
        x.master();
      }).fail(function (resp) {
        prestashop.emit('steco_payment_master_error', {eventType: 'validate_address', resp: resp}); 
      });
  },
  save_address: function(type,x){
      var $form = type ? $('.st_address_form_invoice .steco_new_address_form') : $('.st_address_form_delivery .steco_new_address_form');
      $.ajax(
      {
          type: 'POST',
          url: (type ? $form.attr('action').replace(/&items=\d+/,'&items=0') : $form.attr('action').replace(/&items=\d+/,'&items=3'))+'&final=1',
          data: $form.serialize(),
          dataType: 'json',
          cache: false
      }).then(function (resp) {
        if(resp.is_address_saved===0){
          if(type)
            x.process.billing_submit = 2;
          else
            x.process.shipping_submit = 2;
          steco.update_dom(resp);
        }else{
          if(type)
            x.process.billing_submit = 1;
          else{
            x.process.shipping_submit = 1;
            if($form.find('input[name="show_invoice_button"]').prop('checked'))
              x.process.billing_submit = 1;
          }
        }
        x.master();
      }).fail(function (resp) {
        prestashop.emit('steco_payment_master_error', {eventType: 'newAddress', resp: resp}); 
      });
  },
  save_delivery: function(){
    var $deliveryMethodForm = $(steco_delivery.deliveryFormSelector);
    var requestData = $deliveryMethodForm.serialize();
    $.ajax(
    {
        type: 'POST',
        url: $deliveryMethodForm.data('url-update'),
        data: requestData,
        dataType: 'json',
        cache: false
    }).then(function (resp) {
      steco_payment.process.delivery_submit = 1;
      steco_payment.master();
    }).fail(function (resp) {
      prestashop.emit('steco_payment_master_error', {eventType: 'saveDelivery', resp: resp}); 
    });
  },
  save_colissimo: function(){
    $.ajax(
    {
        type: 'POST',
        url: steasycheckout.urls.save_colissimo,
        data:{
          mobile_phone: steco_delivery.colissimo_get_mobile_phone()
        },
        dataType: 'json',
        cache: false
    }).then(function (resp) {
      steco_payment.process.colissimo = resp.r ? 1 : 2;
      steco_payment.master();
    }).fail(function (resp) {
      prestashop.emit('steco_payment_master_error', {eventType: 'saveColissimo', resp: resp}); 
    });
  },
  reload_payments_for_payline: function(){
    $.ajax({
      url: steasycheckout.urls.payment,
      method: 'POST',
      dataType: 'json',
      cache: false
    }).then(function (resp) {
      //payline xueyao customer secure_key suo yi zai yong hu zhu che hou shuaxin
        steco_payment.process.payline = 1;
        steco.update_dom(resp);
        steco_payment.master();
    }).fail(function(resp) {
      prestashop.emit('stecoHandleError', {eventType: 'reloadPaymentsForPayline', resp: resp});
    });
  },
  check_ddw: function(){
    if (!ddw.checkNextStep()) {
      steco_payment.process.ddw = 2;
      ddw.showRequiredError();
      $('body,html').animate({
        scrollTop: $('#delivery-date-panel').offset().top
      }, 'fast');
    } else{
      steco_payment.process.ddw = 1;
    }
    steco_payment.master();
  },
  get_address_info: function(){
    $.ajax(
    {
        type: 'POST',
        url: steasycheckout.urls.get_address_info,
        dataType: 'json',
        cache: false
    }).then(function (resp) {
      if(typeof(resp.stripe_billing_address)!='undefined'){
        steco_payment.process.stripejs_new = 1;
        if(typeof stripejs!='undefined')
          stripejs.stripe_billing_address = resp.stripe_billing_address;
      }else
        steco_payment.process.stripejs_new = 2;
      steco_payment.master();
    }).fail(function (resp) {
      prestashop.emit('steco_payment_master_error', {eventType: 'getAddressInfo', resp: resp}); 
    });
  },
  save_delivery_message: function(){
    $.ajax({
          url: steasycheckout.urls.set_message,
          method: 'POST',
          dataType: 'json',
          data: {
              delivery_message: $('#delivery_message').val(),
          },
          cache: false
        }).then(function (resp) {
          steco_payment.process.delivery_message_submit = 1;
          steco_payment.master();
        }).fail(function(resp) {
          prestashop.emit('steco_payment_master_error', {eventType: 'setMessage', resp: resp});          
        });
  },
  confirm: function(){
    var option = this.getSelectedOption();
    if (option) {
      var module_name = $('#'+option).data('module-name');
      if($('#'+option).hasClass('stripe-official'))// stripe-official mei you module-name
          return false;
      if(steasycheckout.payments_no_submit && module_name){
        if((steasycheckout.payments_no_submit+',').indexOf((module_name+',')) != -1)
          return false;
      }
      // console.log('submited');
      $('#pay-with-' + option + '-form form').submit();
    }
  }
};

